Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 639054 - sys-devel/gcc with /bin/sh ->dash : /usr/sbin/fix_libtool_files.sh: 41: [: unexpected operator
Summary: sys-devel/gcc with /bin/sh ->dash : /usr/sbin/fix_libtool_files.sh: 41: [: un...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Toolchain Maintainers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: nonbash
  Show dependency tree
 
Reported: 2017-11-28 13:26 UTC by Paolo Pedroni
Modified: 2017-12-04 23:27 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Paolo Pedroni 2017-11-28 13:26:24 UTC
# ls -l /bin/sh
lrwxrwxrwx 1 root root 4 28 nov 01.00 /bin/sh -> dash

# /usr/sbin/fix_libtool_files.sh 6.4.0
/usr/sbin/fix_libtool_files.sh: 41: [: unexpected operator
Scanning libtool files for hardcoded gcc library paths...
 *   [1/12] Scanning /lib ...
 *   [2/12] Scanning /usr/lib ...
 *   [3/12] Scanning /lib32 ...
 *   [4/12] Scanning /lib64 ...
 *   [5/12] Scanning /usr/games/lib ...
 *   [6/12] Scanning /usr/games/lib32 ...
 *   [7/12] Scanning /usr/games/lib64 ...
 *   [8/12] Scanning /usr/lib32 ...
 *   [9/12] Scanning /usr/lib64 ...
 *   [10/12] Scanning /usr/local/lib ...
 *   [11/12] Scanning /usr/local/lib32 ...
 *   [12/12] Scanning /usr/local/lib64 ...

# eselect sh set bash
# ls -l /bin/sh
lrwxrwxrwx 1 root root 4 28 nov 14.01 /bin/sh -> bash
# /usr/sbin/fix_libtool_files.sh 6.4.0
Scanning libtool files for hardcoded gcc library paths...
 *   [1/12] Scanning /lib ...
 *   [2/12] Scanning /usr/lib ...
 *   [3/12] Scanning /lib32 ...
 *   [4/12] Scanning /lib64 ...
 *   [5/12] Scanning /usr/games/lib ...
 *   [6/12] Scanning /usr/games/lib32 ...
 *   [7/12] Scanning /usr/games/lib64 ...
 *   [8/12] Scanning /usr/lib32 ...
 *   [9/12] Scanning /usr/lib64 ...
 *   [10/12] Scanning /usr/local/lib ...
 *   [11/12] Scanning /usr/local/lib32 ...
 *   [12/12] Scanning /usr/local/lib64 ...

# emerge --info
Portage 2.3.13 (python 3.5.4-final-0, default/linux/amd64/13.0/desktop/plasma/systemd, gcc-7.2.0, glibc-2.25-r9, 4.12.12-gentoo x86_64)
=================================================================
System uname: Linux-4.12.12-gentoo-x86_64-AMD_Phenom-tm-_II_X6_1100T_Processor-with-gentoo-2.4.1
KiB Mem:    12024484 total,   7164968 free
KiB Swap:   12582908 total,  12582908 free
Timestamp of repository gentoo: Tue, 28 Nov 2017 08:15:01 +0000
Head commit of repository gentoo: a4addd04c4f6233c75589c49fa28ee0e5d82c03f
sh dash 0.5.9.1-r3
ld GNU gold (Gentoo 2.29.1 p3 2.29.1) 1.14
distcc 3.2rc1 x86_64-pc-linux-gnu [enabled]
ccache version 3.3.4 [disabled]
app-shells/bash:          4.3_p48-r1::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.26.1-r1::gentoo
dev-lang/python:          2.7.14::gentoo, 3.5.4::gentoo
dev-util/ccache:          3.3.4-r1::gentoo
dev-util/cmake:           3.8.2::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/sandbox:         2.10-r4::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69::gentoo
sys-devel/automake:       1.15.1-r1::gentoo
sys-devel/binutils:       2.29.1-r1::gentoo
sys-devel/gcc:            7.2.0::gentoo
sys-devel/gcc-config:     1.8-r1::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1::gentoo
sys-kernel/linux-headers: 4.10::gentoo (virtual/os-headers)
sys-libs/glibc:           2.25-r9::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.europe.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-extra-opts:

x-portage
    location: /usr/local/portage
    masters: gentoo
    priority: 0

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=amdfam10 -msahf -mlzcnt -mpopcnt --param l1-cache-size=64 --param l1-cache-line-size=64 --param l2-cache-size=512 -flto=7 -fuse-linker-plugin -floop-nest-optimize -ftree-loop-distribution -fgraphite-identity -ftree-vectorize"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=amdfam10 -msahf -mlzcnt -mpopcnt --param l1-cache-size=64 --param l1-cache-line-size=64 --param l2-cache-size=512 -flto=7 -fuse-linker-plugin -floop-nest-optimize -ftree-loop-distribution -fgraphite-identity -ftree-vectorize"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going y --with-bdeps y"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs cgroup compress-build-logs config-protect-if-modified distcc distlocks ebuild-locks ipc-sandbox merge-sync multilib-strict news parallel-fetch protect-owned sandbox sfperms split-elog split-log strict test unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.halifax.rwth-aachen.de/gentoo/ http://tux.rainside.sk/gentoo/ http://gentoo.mneisen.org/ http://gentoo.tiscali.nl/ http://gentoo.inode.at/"
LANG="it_IT.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu -Wl,--sort-common -flto=7 -fuse-linker-plugin -floop-nest-optimize -ftree-loop-distribution -fgraphite-identity -ftree-vectorize"
MAKEOPTS="-j12 -l6"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac aalib acl acpi activities adns alsa amd64 ao audiofile bash-completion bluetooth branding bzip2 cairo caps cdda cddb cdparanoia cdr cli cracklib crypt css cups curl cxx dbus declarative dga djvu dri dts dvd dvdr emboss encode exif expat fbcon ffmpeg fftw firefox flac fontconfig fortran ftp gd gdbm geoip gif gimp glamor gmp gnutls gphoto2 gpm graphviz gtk handbook iconv icu idn ieee1394 imagemagick imlib ipv6 java javascript jbig jpeg jpeg2k kde kipi kwallet lame lcms libass libcaca libnotify libsamplerate lm_sensors lua lzma lzo mad mmap mng modules mp3 mp4 mpeg mplayer multilib musicbrainz ncurses nls nptl nsplugin offensive ogg openal openexr opengl openmp pam pango pcre pdf phonon plasma png policykit postscript ppds pulseaudio qml qt3support qt4 qt5 rdesktop readline recode samba scanner sctp sdl seccomp session sndfile sockets speex spell sqlite sqlite3 ssl startup-notification svg symlink syslog systemd sysvipc taglib theora threads tidy tiff truetype udev udisks unicode upower usb vaapi vcd vdpau vim-syntax vnc vorbis wayland widgets win32codecs wmf wxwidgets x264 xattr xcb xcomposite xine xinerama xml xpm xscreensaver xv xvid yahoo zlib" ABI_X86="64" ALSA_CARDS="hda-intel virmidi" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="kodak ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext popcnt sse sse2 sse3 sse4a" CURL_SSL="gnutls" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="libinput" KERNEL="linux" L10N="it en" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver" LINGUAS="it it_IT" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-0" POSTGRES_TARGETS="postgres9_5" PYTHON_TARGETS="python2_7 python3_5 pypy pypy3" RUBY_TARGETS="ruby22" SANE_BACKENDS="epson epson2" USERLAND="GNU" VIDEO_CARDS="radeon r600" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Yann Leprince 2017-12-04 09:15:25 UTC
This is due to using the operator == instead of = in the EPREFIX comparison. The checkbashisms tool finds another problem on the same line:

% checkbashisms /usr/sbin/fix_libtool_files.sh     
possible bashism in /usr/sbin/fix_libtool_files.sh line 41 ($EUID should be "$(id -u)"):
if [ ${EUID:-0} -ne 0   -a   "${EPREFIX}" == '' ] ; then
possible bashism in /usr/sbin/fix_libtool_files.sh line 41 (should be 'b = a'):
if [ ${EUID:-0} -ne 0   -a   "${EPREFIX}" == '' ] ; then

So this line should be replaced by:
if [ "$(id -u)" -ne 0   -a   "${EPREFIX}" = '' ] ; then
Comment 2 Larry the Git Cow gentoo-dev 2017-12-04 23:27:27 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=dec6b1b3be2b497a5c9e6f068f259c02275781c0

commit dec6b1b3be2b497a5c9e6f068f259c02275781c0
Author:     Sergei Trofimovich <slyfox@gentoo.org>
AuthorDate: 2017-12-04 23:27:09 +0000
Commit:     Sergei Trofimovich <slyfox@gentoo.org>
CommitDate: 2017-12-04 23:27:21 +0000

    sys-devel/gcc: fix bash-specific == comparison, bug #639054
    
    Reported-by: Paolo Pedroni
    Closes: https://bugs.gentoo.org/639054
    Package-Manager: Portage-2.3.16, Repoman-2.3.6

 sys-devel/gcc/files/fix_libtool_files.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 3 Sergei Trofimovich gentoo-dev 2017-12-04 23:27:57 UTC
I've pushed s/==/=/ to the tree. Thanks everyone!